//
// BrackRec.cs -     .
//      q-:
//
// 1. S -> (B)B
// 2. B -> (B)B
// 3. B -> empty
//

using System;
using System.Collections;

class Parser 
{
	//     S, B,   (botoom).
	//        .
	const int  S = 256;
	const int  B = 257;
	const int  bottom = 300;
 
	// ,     
	Stack stck;

	public Parser()
	{
        stck = new Stack();
	}
	
	//   
	public void Init() 
	{
		//  
		stck.Clear();
		stck.Push(bottom);
		stck.Push(S);
	}
	
	//        ,
	//      
	public bool Start(string str, out int i, out string ermes) 
	{
		ermes = "";
		i = 0; //   

		//   
		Init();

		int step = 0;
		//   
		while(true) 
		{
			//      ,  ,  
			Console.WriteLine("step {0}: str[{1}] = {2}", step++, i, str[i]);
			//     
			int sym = (int)(stck.Peek());
			switch(sym) 
			{
					//     
				case S:
				switch(str[i]) 
				{
					case '(': // [S, (]
						stck.Pop();
						stck.Push(B);
						stck.Push((int)')');
						stck.Push(B);
						i++; //   
						break;
					case ')': // [S, )] - )     
						ermes = "Position " + i + " Error 1: \')\' can not is in begin!";
						return false;
					case '\n': // [S,  ]
						ermes = "Position " + i + " Error 2: Empty string!";
						return false;
					default: // ,    
						ermes = "Position " + i + " Incorrect symbol! " + str[i];
						return false;
				}
					break;

					//     
				case B:
				switch(str[i]) 
				{
					case '(': // [B, (]
						stck.Pop();
						stck.Push(B);
						stck.Push((int)')');
						stck.Push(B);
						i++; //   
						break;
					case ')': // [B, )] -    
						stck.Pop();
						break;
					case '\n': // [B,  ] -   
						stck.Pop();
						break;
					default: // ,    
						ermes = "Position " + i + "Incorrect symbol! " + str[i];
						return false;
				}
					break;

				case ')':
					//     
				switch(str[i]) 
				{
					case '(': // [), (] -   
						ermes = "Position " + i + " Error 3: I want \')\'!";
						return false;
					case ')': // [), )] -    
						stck.Pop(); // 
						i++;		// 
						break;
					case '\n': // [),  ]
						ermes = "Position " + i + " Error 4: I want \')\'!";
						return false;
					default: // ,    
						ermes = "Position " + i + " Incorrect symbol! " + str[i];
						return false;
				}		
					break;

					//     
				case bottom:
				switch(str[i]) 
				{
					case '(': // [bottom, (] -    
						ermes = "Position " + i + " Error 5: Impossible situation [bottom, \'(\']!";
						return false;
					case ')': // [bottom, )] -  )
						ermes = "Position " + i + " Error 6: unnecessary \')\'!";
						return false;
					case '\n': // [bottom,  ] - !
						return true;
					default: // ,    
						ermes = "Position " + i + " Incorrect symbol! " + str[i];
						return false;
				}		
			}
		}
	}
}

